//
//  ViewController.m
//  signals
//
//  Created by atomicpepper on 2/26/17.
//  Copyright © 2017 atomicpepper. All rights reserved.
//

#import "ViewController.h"
#import "ATMPPR_Signal.h"


@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    // Do any additional setup after loading the view.
    [ATMPPR_Signal catchSignals:ATMPPR_Signal.crashSignals signalHandler:^(int signalRaised) {
        NSLog(@"crashing with signal %d (%s)",signalRaised,strForSignal( signalRaised));
    }];

    [ATMPPR_Signal catchSignals:@[@(SIGHUP),@(SIGINFO)] queue:dispatch_get_global_queue(QOS_CLASS_USER_INTERACTIVE, 0) signalHandler:^(int signalRaised) {
        NSLog(@"caught signal %d (%s)",signalRaised,strForSignal( signalRaised));
    }];

}


- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];

    // Update the view, if already loaded.
}



-(void)sendSignal:(int)sigraised {
    kill(NSProcessInfo.processInfo.processIdentifier, sigraised);
}
-(IBAction)ibButton_sigILL:(id)sender { [self sendSignal:SIGILL]; }
-(IBAction)ibButton_sigHUP:(id)sender { [self sendSignal:SIGHUP]; }
-(IBAction)ibButton_sigINFO:(id)sender { [self sendSignal:SIGINFO]; }
-(IBAction)ibButton_sigABRT:(id)sender {
    [ATMPPR_Signal codeThatMayCallAbort:^{
        NSLog(@"about to call abort");
        abort();
        NSLog(@"after call to abort");  // this line is here simply to show that it never gets called
    } abortResponse:^{
        NSLog(@"inside abort catch block");
    }];
}
-(IBAction)ibButton_sigBUS:(id)sender { [self sendSignal:SIGBUS]; }
@end
